<script setup lang="ts">
import { useProductStore } from '@/stores/product'
import { useTypeStore } from '@/stores/type'
import type { Product } from '@/types/Product'
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useSubCategoryStore } from '@/stores/subCategory'
import { useSizeStore } from '@/stores/size'
import { useCategoryStore } from '@/stores/category'
const products = computed(() => productStore.products)
const refForm = ref<VForm | null>(null)
const productStore = useProductStore()
const categoryStore = useCategoryStore()
const subCategoryStore = useSubCategoryStore()
const sizeStore = useSizeStore()
const dialog = ref(false)

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await productStore.saveProduct()
  productStore.closeDialog()
}

onMounted(async () => {
  await productStore.getProducts()
  await categoryStore.getCategorys()
  await subCategoryStore.getSubCategorys()
  await sizeStore.getSizes()
})

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'รูปภาพ',
    key: 'image'
  },
  {
    title: 'ชื่อ',
    key: 'name',
    value: 'name'
  },
  {
    title: 'ราคา',
    key: 'price',
    value: 'price'
  },
  {
    title: 'ประเภท',
    key: 'category',
    value: 'category.name'
  },
  {
    title: 'ประเภทเครื่องดื่ม',
    key: 'subCategory',
    value: (item: any | Product) => {
      if (item.subCategorys && item.subCategorys.length > 0) {
        return item.subCategorys.map((r: any) => r.name).join(', ')
      } else {
        return '-'
      }
    }
  },
  {
    title: 'ไซส์',
    key: 'size',
    value: (item: any | Product) => {
      if (item.sizes && item.sizes.length > 0) {
        return item.sizes.map((r: any) => r.name).join(', ')
      } else {
        return '-'
      }
    }
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
</script>
<template>
  <div>
    <v-sheet>
      <v-container fluid>
        <v-data-table :headers="headers" :items="productStore.products" height="480">
          <template v-slot:top>
            <v-toolbar flat>
              <v-toolbar-title>Product Management</v-toolbar-title>
              <v-divider class="mx-4" inset vertical></v-divider>
              <v-spacer></v-spacer>
              <v-dialog v-model="productStore.dialog" persistent width="1024">
                <template v-slot:activator="{ props }">
                  <v-btn size="40px" v-bind="props" prepend-icon="mdi-plus-thick" class="mr-5">
                    <!-- New User -->
                  </v-btn>
                </template>
                <v-card style="background-color: #fff5e8">
                  <v-card-title>
                    <span class="text-h5">New Product</span>
                  </v-card-title>
                  <v-card-text>
                    <v-form ref="refForm" v-model="productStore.form" @submit.prevent="productStore.onSubmit">
                      <v-container>
                        <v-row>
                          <v-col cols="12" sm="12" md="4">
                            <v-text-field v-model="productStore.editedProduct.name"
                              :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Name"
                              variant="outlined" filled rounded>
                            </v-text-field>
                          </v-col>
                          <v-col cols="12" sm="12" md="4">
                            <v-text-field v-model="productStore.editedProduct.price"
                              :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Price"
                              variant="outlined" filled rounded>
                            </v-text-field>
                          </v-col>
                          <v-col cols="12" sm="12" md="4">
                            <v-combobox v-model="productStore.editedProduct.category" :items="categoryStore.categorys"
                              item-title="name" item-value="id" label="เลือกประเภท" :return-object="true"
                              variant="outlined" filled rounded></v-combobox>

                            <!-- <v-text-field
                          v-model="productStore.editedProduct.type"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Type"
                        >
                        </v-text-field> -->
                          </v-col>
                          <v-col cols="12" sm="12" md="4">
                            <v-img :src="'http://localhost:3000/images/products/' +
          productStore.editedProduct.image
          " style="width: 100%; height: 200px; object-fit: cover ">
                            </v-img>
                          </v-col>
                          <v-col cols="12" sm="12" md="4">
                            <v-file-input v-model="productStore.editedProduct.files" :rules="[
          (value) => {
            return (
              !value ||
              !value.length ||
              value[0].size < 2000000 ||
              'Image size should be less than 2 MB!'
            )
          }
        ]" accept="image/png, image/jpeg" placeholder="Pick an image" prepend-icon="mdi-camera" label="Image"
                              variant="outlined" filled rounded></v-file-input>
                          </v-col>

                          <v-col cols="12" sm="12" md="2">
                            <v-combobox v-if="productStore.checkDrink()" label="Sub Category"
                              :items="subCategoryStore.subCategorys" item-title="name" item-value="id"
                              :return-object="true" multiple v-model="productStore.editedProduct.subCategorys"
                              variant="outlined" filled rounded></v-combobox>
                          </v-col>
                          <v-col cols="12" sm="12" md="2">
                            <v-combobox v-if="productStore.checkDrink()" label="Size" :items="sizeStore.sizes"
                              item-title="name" item-value="id" :return-object="true" multiple
                              v-model="productStore.editedProduct.sizes" variant="outlined" filled rounded
                              ></v-combobox>
                          </v-col>
                        </v-row>
                      </v-container>
                    </v-form>
                    <small>*indicates required field</small>
                  </v-card-text>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn variant="text" @click="save"> Save </v-btn>
                    <v-btn variant="text" @click="productStore.closeDialog"> Close </v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>

              <v-dialog v-model="productStore.deleteDialog" max-width="500px">
                <v-card>
                  <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn variant="text" @click="productStore.closeDelete">Cancel</v-btn>
                    <v-btn variant="text" @click="productStore.deleteItemConfirm">OK</v-btn>
                    <v-spacer></v-spacer>
                  </v-card-actions>
                </v-card>
              </v-dialog>
            </v-toolbar>
          </template>

          <!-- <v-table fixed-header height="530">
          <thead>
            <tr>
              <th>Id</th>
              <th>Image</th>
              <th>Name</th>
              <th>Price</th>
              <th>Category</th>
              <th>Sub category</th>
              <th>Sizes</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in productStore.products" :key="item.id">
              <td>{{ item.id }}</td>
              <td>
                {{ item.image }}
                <v-img :src="'http://localhost:3000/images/products/' + item.image" width="100"></v-img>
              </td>
              <td>{{ item.name }}</td>
              <td>{{ item.price }}</td>
              <td>{{ item.category}}</td>
              <td>{{ item.subCategorys }}</td>
              <td>{{ item.sizes }}</td>
              <td>
                <v-icon size="small" class="me-2" @click="productStore.editItem(item)"> mdi-pencil </v-icon>
                <v-icon size="small" @click="productStore.deleteItem(item)"> mdi-delete </v-icon>
              </td>
            </tr>
          </tbody> -->

          <template v-slot:[`item.actions`]="{ item }">
            <div>{{ item.id }}</div>
            <v-icon size="small" class="me-2" @click="productStore.editItem(item)">
              mdi-pencil
            </v-icon>
            <v-icon size="small" @click="productStore.deleteItem(item)"> mdi-delete </v-icon>
          </template>

          <template v-slot:[`item.image`]="{ item }">
            <v-img :src="'http://localhost:3000/images/products/' + item.image" width="100px" rounded>{{
              }}</v-img>
          </template>

          <template v-slot:no-data>
            <v-btn @click="productStore.getProducts()"> Reset </v-btn>
          </template>
        </v-data-table>
      </v-container>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table-data {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
